"""
exE-1.py

B(E)3M33UI - Artificial Intelligence course, FEE CTU in Prague
Model evaluation and diagnostics

Petr Posik, Jiri Spilka, CVUT, Praha 2017
"""

import numpy as np
from sklearn import linear_model, cross_validation, metrics, svm, grid_search, preprocessing
from matplotlib import pyplot as plt

from mpg import load_mpg_for_classification
from plotting import plot_roc


def main():

    # Load data
    X, y = load_mpg_for_classification()
    print('\nThe dataset (X and y) size:')
    print('X: ', X.shape)
    print('y: ', y.shape)

    # scale the data
    sc = preprocessing.StandardScaler()
    X = sc.fit_transform(X)

    # FIXME Task 1: Implement metrics to measure model performance
    raise NotImplementedError
    # <YOUR CODE HERE>

    # FIXME Tasks 2-3: ROC curves
    # # Setup the list of models
    models = []

    # Setup a classifier
    # They can be even pipelines with basis expansion, etc.
    clf = svm.SVC(kernel='rbf', gamma=1, probability=True)
    models.append({'clf': clf, 'descr': 'LR1', 'color': 'b'})

    raise NotImplementedError
    # <YOUR CODE HERE>

    # FIXME Tasks 4-5: Model evaluation train/test split

    raise NotImplementedError
    # <YOUR CODE HERE>

    print('\nShapes of training and testing X:')
    print(Xtr.shape)
    print(Xtst.shape)
    print('Shapes of training and testing y:')
    print(ytr.shape)
    print(ytst.shape)

    # Fit the model to training data, validate on test data
    raise NotImplementedError
    # <YOUR CODE HERE>

    print('\nThe training and testing accuracies when simple split is used:')
    print('train acc:', acc_tr)
    print('test  acc:', acc_tst)

    # FIXME Tasks 6-10: Cross-validation and manual tuning
    # Use 5-fold cross-validation
    # Play with SVM parameters and try to understand them
    folds = 5
    raise NotImplementedError
    # <YOUR CODE HERE>

    print("\n{:d}-cross-validation ACC: {:.2f} (+/- {:.2f})".format(folds, accuracies.mean(), accuracies.std()))
    print('accuracies:', accuracies)

    # FIXME Tasks 11-13: Cross-validation and grid search
    raise NotImplementedError
    # <YOUR CODE HERE>

    print("\nAFTER TUNING: ")
    print('Best parameters found:')
    print(clf.best_params_)
    print('CV score for the best parameter values:')
    print(clf.best_score_)

    # Print the scores of the TUNED classifier for training and testing data
    raise NotImplementedError
    # <YOUR CODE HERE>

    print('\nThe training and testing accuracies for TUNED classifier:')
    print('train acc:', acc_tr)
    print('test  acc:', acc_tst)

# catch all exceptions
try:
    plt.ion()  # turn interactive mode on so our plots stay open like in matlab
    main()

except BaseException as e:
    import traceback
    traceback.print_exc()  # mimic printing traceback from an exception
    plt.ioff()  # turn interactive mode off
    plt.show()  # show whatever we have to show, it will stay open because we turned interactive mode off

